# 零、前言

拥有设计模式的知识可以帮助开发人员改进代码库，促进代码重用，并使架构更加健壮。随着语言的发展，新特性在被大量采用之前需要时间才能被完全理解。这本书的任务是简化最新趋势的采用，并为程序员提供良好的实践。

# 这本书是给谁的

这本书是为每一个想要编写高质量代码的 Java 开发人员准备的。这本书讨论了许多开发人员在编写代码时经常忽略的最佳实践。这本书还涵盖了许多设计模式。设计模式只不过是解决特定问题的最佳实践，这些问题已经过开发人员社区的尝试和测试。

# 充分利用这本书

有 Java 经验的读者将能够从本书中获得最大的收获。建议读者尝试探索和使用各章中提供的代码示例。

# 下载示例代码文件

您可以从您的帐户[下载本书的示例代码文件 www.packtpub.com](http://www.packtpub.com)。如果您在其他地方购买了本书，您可以访问[www.packtpub.com/support](http://www.packtpub.com/support)并注册，将文件直接通过电子邮件发送给您。

您可以通过以下步骤下载代码文件：

1.  在[登录或注册 www.packtpub.com](http://www.packtpub.com/support)。
2.  选择“支持”选项卡。
3.  点击代码下载和勘误表。
4.  在搜索框中输入图书名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用最新版本的解压缩或解压缩文件夹：

*   用于 Windows 的 WinRAR/7-Zip
*   Mac 的 Zipeg/iZip/UnRarX
*   用于 Linux 的 7-Zip/PeaZip

这本书的代码包也托管[在 GitHub 上](https://github.com/PacktPublishing/Design-Patterns-and-Best-Practices-in-Java)。如果代码有更新，它将在现有的 GitHub 存储库中更新。

我们的丰富书籍和视频目录中还有其他代码包，可在[这个页面](https://github.com/PacktPublishing/)上找到。看看他们！

# 下载彩色图像

我们还提供了一个 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。您可以从[这个页面](http://www.packtpub.com/sites/default/files/downloads/DesignPatternsandBestPracticesinJava_ColorImages.pdf)下载。

# 使用的约定

这本书中使用了许多文本约定。

`CodeInText`：表示文本中的代码字、数据库表名、文件夹名、文件名、文件扩展名、路径名、虚拟 URL、用户输入和 Twitter 句柄。下面是一个示例：“通过向其声明中添加`synchronized`关键字，使`getInstance`方法线程安全。”

代码块设置如下：

```java
public class Car extends Vehicle
{
  public Car(String name)
  {
    super(name)
  }
}
```

任何命令行输入或输出的编写方式如下：

```java
java --list-modules
```

**粗体**：表示一个新术语、一个重要单词或屏幕上显示的单词。例如，菜单或对话框中的单词会像这样出现在文本中。下面是一个示例：“在进行此更改之前，您需要将完整的 **Java 运行时环境**（**JRE**）作为一个整体加载到服务器或机器上以运行 Java 应用。”

警告或重要提示如下所示。

提示和窍门是这样出现的。