# 十七、为 Java 平台做贡献

在最后一章中，我们展望了 Java 平台在 Java11 之外的未来发展。我们查看了 Java19.3 和 19.9 的计划，以及将来可能会看到的进一步变化。我们首先简要概述了 JEP，并涵盖了现有的 JEP 和正在进行的特别项目。

Java 平台未来的关键是 Java 社区。这是本章的重点。我们将讨论 Java 社区以及开发人员如何为 Java 平台做出贡献。具体来说，我们将介绍以下与 Java 社区相关的主题：

*   Java 社区
*   参与 Java 用户组
*   **Java 社区流程**（**JCP**）
*   技术网络
*   撰写技术文章

# 技术要求

本章介绍 Java11，Java 平台的**标准版**（**SE**）可从 [Oracle 官网](http://www.oracle.com/technetwork/java/javase/downloads/index.html)下载。

IDE 包就足够了。来自 JetBrains 的 IntelliJ IDEA 用于与本章相关的所有编码。[IntelliJ IDEA 的社区版可从以下网站下载](https://www.jetbrains.com/idea/features/)。

# Java 社区

Java 社区由数以百万计的开发人员组成，他们以一种或多种方式相互支持并为 Java 平台做出贡献。这就是 Java 是如此强大的开发平台的原因之一。社区参与可以包括通过`@java`关注和参与 Twitter，或者在 Facebook 上喜欢`<3 Java`。

还有大量的列表服务、博客和论坛，您可以参与其中，帮助开发人员解答问题。这是一个很好的方法来支持社区并及时了解 Java 平台的变化。并不是所有 Oracle 的博客都是针对 Java 的，但至少是 Java 的附属博客。

您可以在[这个页面](http://blogs.oracle.com)浏览 Oracle 的博客目录。

互联网上有几个 Java 论坛。甲骨文在[这个页面](http://community.oracle.com)开设了一个官方的 Java 社区空间。Java 社区空间组织为以下空间：

| JavaOne | Java 冠军 |
| --- | --- |
| #Java20 | Java 社区流程 |
| Java 本质论 | Java API |
| 数据库连接 | Java SE |
| Java 安全性 | Java HotSpot 虚拟机 |
| Java EE | 嵌入式技术 |
| Java 开发工具 | 文章档案 |
| Java.net Forge Sunset | JavaScript Nashorn |
| Java 新空间的构想 | Java 用户组 |
| NightHacking |  |

一些 Java 开发人员在 YouTube 上创建了 HOWTO 视频播放列表，其中许多被学术机构使用。这些可以是有趣的创造，是一个很好的方式回馈社会。

# 参与 Java 用户组

**Java 用户组**也被称为 **JUGs**，由具有社区意识的 Java 专业人士组成，旨在分享他们的 Java 知识。有超过 200 个用户组，参与是自愿的。与其他专业用户群一样，JUGs 提供以下机会：

*   与其他 Java 专业人士联网
*   分享技巧、技巧和资源
*   向他人学习
*   增加 Java 知识

用户组遍布全球。有些是按国家组织的，有些是按城市组织的。当你探索你所在地理区域的用户组时，你可能会发现他们有定期的见面会

# Java 社区流程

**Java 社区流程™**（**JCP™**）是针对 Java 平台开发技术规范标准的结构化方法。所有开发者均可在[这个页面](http://jcp.org)注册。注册后，用户可以查看 **Java 规范请求**（**JSR**）并提交反馈

此外，您甚至可以提交自己的 JSR 建议并加入 JSR 专家组。

在 JCP 站点，您可以搜索和浏览当前 JSR。

# 技术网络

甲骨文拥有一个**甲骨文技术网络**（**OTN**），其成员资格是免费的。详情请访问[这个页面](https://www.oracle.com/technetwork/community/join/overview/index.html)。

OTN 会员有以下好处：

*   参加论坛的机会
*   自由软件
*   免费在线研讨会
*   访问 Java API 文档
*   社区参与
*   获取技术文章
*   Oracle 员工的博客
*   访问示例代码
*   新闻稿订阅
*   活动、书籍、产品和其他资源的折扣
*   社会参与途径：
*   推特
*   YouTube
*   脸书
*   博客

# 撰写技术文章

如果你是一个学者，专业人士，或只是想发表一篇文章，你可以提交给甲骨文。如果被接受，甲骨文将在 OTN 的保护下发布它们

[以下网站](https://www.oracle.com/technetwork/articles/otn-submit-100481.html)提供了为 Oracle 撰写技术文章的详细信息。

本网站提供以下分类信息：

*   编辑需要
*   文章规范
*   提交和编辑过程
*   发表文章的授权
*   你的文章提交的回复
*   编辑过程
*   委托文章

# 总结

在本章中，我们讨论了 Java 社区以及可以为 Java 平台做出贡献的方法。具体来说，我们讨论了 Java 社区，参与了 Java 用户组 JCP 和 OTN，并为 Oracle 撰写了技术文章。

你做到了书的结尾。谢谢你的阅读。快乐的编码！

# 问题

1.  什么是 JUG？
2.  有多少个 JUG？
3.  JUG 是如何组织的？
4.  OTN 会员资格提供什么样的折扣？
5.  什么是 **Java 社区流程™**？
6.  Java 社区有多大？
7.  列出加入 JUG 的四个好处。
8.  您可以从哪里了解到有关为 Oracle 编写技术文章的更多信息？
9.  向 JSR 提交反馈的先决条件是什么？
10.  谁可以提交 JSR？